import { EventEmitter, Injector, OnChanges, OnDestroy, OnInit, ViewContainerRef } from '@angular/core';
import { FastFormGroup } from '../../control/fast-form-group';
import { FastFormSubmitEvent } from '../../model';
import { ControlFactoryService } from '../../service/control-factory.service';
import { ValidatorFactoryService } from '../../validation/validator-factory.service';
import { FormRenderService } from '../../internal/form-render.service';
import { HttpClient } from '@angular/common/http';
import { ActionService } from '../../actions/action.service';
import { ActionEvent } from '../../actions/models';
import { ArrayIndexDirective } from '../../actions/array-index.directive';
import { ControlRegistry } from '../../internal/control/control-registry.service';
import * as i0 from "@angular/core";
export declare class FastFormGroupComponent implements OnChanges, OnInit, OnDestroy {
    private controlFactory;
    private validatorFactory;
    private formRenderService;
    private injector;
    private controlRegistry;
    private indexDirective?;
    private http?;
    endpoint: string;
    componentViewContainerRef: ViewContainerRef;
    action: EventEmitter<ActionEvent>;
    submitEvent: EventEmitter<FastFormSubmitEvent>;
    private _actionService;
    private _actionsSub;
    _formGroup: FastFormGroup;
    set formGroup(formGroup: FastFormGroup);
    constructor(controlFactory: ControlFactoryService, validatorFactory: ValidatorFactoryService, formRenderService: FormRenderService, injector: Injector, controlRegistry: ControlRegistry, actionService: ActionService, indexDirective?: ArrayIndexDirective | undefined, http?: HttpClient | undefined);
    ngOnInit(): void;
    ngOnChanges(): void;
    ngOnDestroy(): void;
    processOnSubmit(event: unknown): void;
    private render;
    private createComponent;
    static ɵfac: i0.ɵɵFactoryDeclaration<FastFormGroupComponent, [null, null, null, null, null, { optional: true; }, { optional: true; }, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FastFormGroupComponent, "aff-form-group", never, { "endpoint": "endpoint"; "formGroup": "formGroup"; }, { "action": "action"; "submitEvent": "submitEvent"; }, never, never, false, never>;
}
