import { AbstractControl, AbstractControlOptions, FormGroup } from '@angular/forms';
import { Question } from '../model';
import { ControlFactoryService } from '../service/control-factory.service';
import { Observable } from 'rxjs';
import { ActionEvent } from '../actions/models';
import { FromActionControlInternal } from '../internal/action/action-control-internal';
import { FormActionGroupInternal } from '../internal/action/action-group-internal';
export declare class FastFormGroup extends FormGroup {
    private controlFactory;
    readonly questionChanges: Observable<Array<Question>>;
    actionEvents: Observable<ActionEvent>;
    index: number | null;
    readonly actions: {
        [key: string]: FromActionControlInternal | FormActionGroupInternal;
    };
    private _questionChanges$;
    private _actions$;
    private _questions;
    get questions(): Array<Question>;
    private get mergedControls();
    constructor(questions: Array<Question>, controlFactory: ControlFactoryService, options?: AbstractControlOptions);
    get(path: string): AbstractControl | null;
    setQuestions(questions: Array<Question>): void;
    addControl(name: string, control: AbstractControl, options?: {
        emitEvent?: boolean | undefined;
    } | undefined): void;
    private createChildControls;
    private validateQuestions;
}
