import { AbstractControl, FormArray, FormGroup } from '@angular/forms';
import { EmitEventOption, IndexOption } from '../model';
import { InternalControlType } from './models';
export declare class ControlWrapper {
    private id;
    private control;
    private action;
    constructor(id: string, control: AbstractControl, controlType: InternalControlType);
    static forFormControl<T extends AbstractControl>(id: string, formControl: T): ControlWrapper;
    static forFormArray<T extends FormArray>(id: string, formArray: T): ControlWrapper;
    static forAction(id: string, actionControl: AbstractControl): ControlWrapper;
    addToParent(parent: FormGroup | FormArray, options?: IndexOption & EmitEventOption): void;
    private addToGroup;
    private addToArray;
}
