import { ComponentRef, Injector, ViewContainerRef } from '@angular/core';
import { DynamicFormDefinition, Question } from '../model';
import { AbstractControl } from '@angular/forms';
import { ControlRegistry } from './control/control-registry.service';
import { ActionService } from '../actions/action.service';
import { ArrayIndexDirective } from '../actions/array-index.directive';
import * as i0 from "@angular/core";
export declare class FormRenderService {
    private controlRegistry;
    private injector;
    constructor(controlRegistry: ControlRegistry, injector: Injector);
    renderOnly<T>(viewContainerRef: ViewContainerRef, control: AbstractControl, opts: {
        injector: Injector;
    }): ComponentRef<T>;
    render<T>(viewContainerRef: ViewContainerRef, parent: AbstractControl, question: Question, formDefinition: DynamicFormDefinition, injector: Injector, actionService?: ActionService, indexDirective?: ArrayIndexDirective): ComponentRef<T>;
    private createProviders;
    private createControlId;
    private shouldInitialize;
    private initializeComponent;
    private initializeFormArrayComponent;
    private initializeFormInlineComponent;
    private initializeFormGroupComponent;
    private initializeFormControlComponent;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormRenderService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FormRenderService>;
}
