import { Injector } from '@angular/core';
import { InternalValidator } from './models';
import { ValidatorDefinition } from './validator-definition.util';
import { AsyncValidatorFn, ValidatorFn } from '@angular/forms';
import { ValidatorType } from '../../validation/symbols';
export declare class ValidatorRegistry {
    private injector;
    private validators;
    constructor(injector: Injector, validatorsPerModule: Array<Array<InternalValidator>>);
    hasSyncValidator(id: string): boolean;
    hasAsyncValidator(id: string): boolean;
    hasValidator(id: string, type: ValidatorType): boolean;
    getSyncValidator(def: ValidatorDefinition): ValidatorFn;
    getAsyncValidator(def: ValidatorDefinition): AsyncValidatorFn;
    getValidator(def: ValidatorDefinition, type: ValidatorType): ValidatorFn | AsyncValidatorFn;
    private createValidator;
    private getValidatorType;
    private validate;
}
