import { ControlRegistry } from '../internal/control/control-registry.service';
import { AbstractControl, AbstractControlOptions, FormArray, FormControl, FormControlOptions, FormControlState, FormGroup } from '@angular/forms';
import { ControlWrapperV2 } from '../internal/control-wrapper-v2';
import { ValidatorFactoryService } from '../validation/validator-factory.service';
import { TypedQuestion } from '../question-definition';
import * as i0 from "@angular/core";
export declare class ControlFactoryV2 {
    private readonly validatorFactory;
    private readonly cr;
    constructor(validatorFactory: ValidatorFactoryService, cr: ControlRegistry);
    create(wrapper: ControlWrapperV2): AbstractControl;
    control<T>(state: FormControlState<T> | T, question: TypedQuestion<T> & FormControlOptions & {
        nonNullable: true;
    }): FormControl<T>;
    control<T>(state: FormControlState<T> | T, question: TypedQuestion<T> & FormControlOptions): FormControl<T | null>;
    dynamicControl(state: FormControlState<any> | any, question: TypedQuestion & FormControlOptions): AbstractControl;
    group(question: TypedQuestion & AbstractControlOptions, groupControls?: {
        [key: string]: AbstractControl;
    }): FormGroup;
    array(question: TypedQuestion & AbstractControlOptions, arrayQuestion?: AbstractControl): FormArray;
    deriveDefinition(key: string | null, control: AbstractControl): ControlWrapperV2;
    private createValidators;
    private createValidatorsByType;
    private createSubGroupControls;
    private createViaFactoryMethod;
    static ɵfac: i0.ɵɵFactoryDeclaration<ControlFactoryV2, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ControlFactoryV2>;
}
