import { AbstractControl, FormArray, FormGroup } from '@angular/forms';
import { EmitEventOption, IndexOption, Question } from '../model';
import { ValidatorFactoryService } from '../validation/validator-factory.service';
import { ControlRegistry } from '../internal/control/control-registry.service';
import { FastFormBuilder } from './fast-form-builder';
import * as i0 from "@angular/core";
export declare class ControlFactoryService {
    private validatorFactory;
    private controlRegistry;
    private fb;
    constructor(validatorFactory: ValidatorFactoryService, controlRegistry: ControlRegistry, fb: FastFormBuilder);
    createFromQuestions(parent: FormGroup, questions: Array<Question>, options?: EmitEventOption): void;
    createFromQuestion(parent: FormGroup | FormArray, question: Question, options?: IndexOption & EmitEventOption): void;
    createFormControl(question: Question): AbstractControl;
    private createControl;
    private createAndInitFormControl;
    private createControlFromDecoratedComponents;
    private createControlDefault;
    private createAndInitFormAction;
    private createAndInitFormGroup;
    static ɵfac: i0.ɵɵFactoryDeclaration<ControlFactoryService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ControlFactoryService>;
}
