import { AbstractControl, FormArray, FormControl, FormControlState, FormGroup } from '@angular/forms';
import { ControlWrapperV2 } from '../internal/control-wrapper-v2';
import { ControlFactoryV2 } from './control-factory-v2.service';
import { ArrayBuilderDefinition, ControlBuilderDefinition, GroupBuilderDefinition } from '../question-definition';
import * as i0 from "@angular/core";
export declare class FastFormBuilder {
    private cf;
    constructor(cf: ControlFactoryV2);
    control<T = any>(state: FormControlState<T> | T, opts: ControlBuilderDefinition & {
        nonNullable: true;
    }): FormControl<T>;
    control<T = any>(state: FormControlState<T> | T, opts: ControlBuilderDefinition): FormControl<T | null>;
    controlGroup<T extends object>(state: T, opts: ControlBuilderDefinition): FormGroup<{
        [K in keyof T]: AbstractControl<T[K]>;
    }>;
    dynamicControl<T = any>(state: FormControlState<T> | T, opts: ControlBuilderDefinition): AbstractControl;
    /**
     * Experimental
     */
    group<T extends object>(question: GroupBuilderDefinition, groupControls?: {
        [key: string]: AbstractControl;
    }): FormGroup<{
        [K in keyof T]: AbstractControl<T[K]>;
    }>;
    /**
     * Experimental
     */
    array<T>(question: ArrayBuilderDefinition, arrayQuestion?: AbstractControl<T>): FormArray<AbstractControl<T>>;
    /**
     * Experimental
     */
    newArrayEntry(array: FormArray): AbstractControl;
    static ɵfac: i0.ɵɵFactoryDeclaration<FastFormBuilder, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FastFormBuilder>;
}
export declare const ControlWrapperKey = "aff_wrapper";
export type WrapperProvider = (AbstractControl | FormGroup | FormControl | FormArray) & {
    [ControlWrapperKey]: ControlWrapperV2;
};
export declare function hasControlWrapper(control: object): control is WrapperProvider;
